﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public class EllipticCurvePointFormatsExtension : TlsExtension, IComputableLength
    {
        public byte FormatsLength { get; set; }

        public EllipticCurvePointFormat[] Formats { get; set; }

        public EllipticCurvePointFormatsExtension()
        {
            Type = TlsExtensionType.EllipticCurvePointFormats;
        }

        public override void Write(BinaryWriter writer)
        {
            base.Write(writer);
            writer.Write(FormatsLength);

            foreach (var f in Formats)
            {
                writer.Write((byte)f);
            }
        }

        public override int ComputeLength()
        {
            return sizeof(byte) + (sizeof(EllipticCurvePointFormat) * Formats.Length);
        }

        public override void SetLength()
        {
            FormatsLength = (byte)Formats.Length;
            Length = (ushort)(sizeof(byte) + FormatsLength);
        }
    }
}
