﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public class EllipticCurvesExtension : TlsExtension, IComputableLength
    {
        public ushort EllipticCurvesLength { get; set; }

        public EllipticCurve[] EllipticCurves { get; set; }

        public EllipticCurvesExtension()
        {
            Type = TlsExtensionType.EllipticCurves;
        }

        public override void Write(System.IO.BinaryWriter writer)
        {
            base.Write(writer);
            writer.Write(EllipticCurvesLength);

            foreach (var c in EllipticCurves)
            {
                writer.Write((ushort)c);
            }
        }

        private int ComputeCurvesLength()
        {
            return sizeof(EllipticCurve) * EllipticCurves.Length;
        }

        public override int ComputeLength()
        {
            return sizeof(ushort) + ComputeCurvesLength();
        }

        public override void SetLength()
        {
            Length = (ushort)ComputeLength();
            EllipticCurvesLength = (ushort)ComputeCurvesLength();
        }
    }
}
