﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public class HeartbeatExtension : TlsExtension, IComputableLength
    {
        public HeartbeatMode Mode { get; set; }

        public HeartbeatExtension()
        {
            Type = TlsExtensionType.Heartbeat;
        }

        public override void Write(BinaryWriter writer)
        {
            base.Write(writer);
            writer.Write((byte)Mode);
        }

        public override int ComputeLength()
        {
            return sizeof(HeartbeatMode);
        }

        public override void SetLength()
        {
            Length = (ushort)ComputeLength();
        }
    }
}
