﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public class HeartbeatRecord : TlsRecord
    {
        public HeartbeatMessageType Type { get; set; }

        public ushort PayloadLength { get; set; }

        public HeartbeatRecord()
        {
            ContentType = TlsRecordType.Heartbeat;
        }

        public override int ComputeDerivedLength()
        {
            return sizeof(HeartbeatMessageType) + sizeof(ushort);
        }

        public override void SetDerivedLength()
        {
            
        }

        public override void Write(BinaryWriter writer)
        {
            base.Write(writer);
            writer.Write((byte)Type);
            writer.Write(PayloadLength);
        }

        public override int ComputeLength()
        {
            return ComputeDerivedLength();
        }
    }
}
