﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public static class IEnumerableExtension
    {
        private static Random _random = new Random();

        public static T[] Shuffle<T>(this IEnumerable<T> elements)
        {
            var items = elements.ToArray();

            for (int i = 0; i < items.Length; i++)
            {
                int i2;

                lock (_random)
                {
                    i2 = _random.Next(items.Length);
                }

                var t = items[i];
                items[i] = items[i2];
                items[i2] = t;
            }

            return items;
        }
    }
}
