﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;

namespace BleedOut
{
    public class SessionTicketExtension : TlsExtension, IComputableLength
    {
        public byte[] Data { get; set; }

        public SessionTicketExtension()
        {
            Type = TlsExtensionType.SessionTicketTls;
        }

        public override void Write(BinaryWriter writer)
        {
            base.Write(writer);
            
            if (Data != null)
            {
                writer.Write(Data);
            }
        }

        public override int ComputeLength()
        {
            return Data != null ? Data.Length : 0;
        }


        public override void SetLength()
        {
            Length = (ushort)ComputeLength();
        }
    }
}
