﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace BleedOut
{
    public static class UI
    {
        public static void DisplayMessage(ConsoleColor tokenColor, char token, string format, params object[] arg)
        {
            Cli.WriteLine(
                string.Format(UIStrings.MessageFormat, tokenColor, token, format),
                arg);
        }

        public static void DisplayInfoMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.White,
                UIStrings.InfoChar,
                format,
                arg);
        }

        public static void DisplayTestMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.White,
                UIStrings.TestChar,
                format,
                arg);
        }

        public static void DisplaySuccessMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.Green,
                UIStrings.SuccessChar,
                format,
                arg);
        }

        public static void DisplayErrorMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.Red,
                UIStrings.ErrorChar,
                format,
                arg);
        }

        public static void DisplayFatalErrorMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.Red,
                UIStrings.FatalErrorChar,
                format,
                arg);
        }

        public static void DisplayStringMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.Yellow,
                UIStrings.StringChar,
                format,
                arg);
        }

        public static void DisplayBinaryMessage(string format, params object[] arg)
        {
            DisplayMessage(
                ConsoleColor.Magenta,
                UIStrings.BinaryChar,
                format,
                arg);
        }

        public static void DisplayFileMessage(string type, string filename)
        {
            UI.DisplayInfoMessage(UIStrings.SavingFormat, type, filename);
        }

        public static void WriteHeader(string format, params object[] arg)
        {
            Cli.WriteHeader(string.Format(format, arg), UIStrings.HeaderStyle);
        }

        public static void DisplayDirections()
        {
            Cli.WriteLine(UIStrings.Directions);
        }
    }
}
